/*
 * Firefly III API v2.1.0
 *
 * This is the documentation of the Firefly III API. You can find accompanying documentation on the website of Firefly III itself (see below). Please report any bugs or issues. You may use the \"Authorize\" button to try the API below. This file was last generated on 2024-09-10T05:07:57+00:00  Please keep in mind that the demo site does not accept requests from curl, colly, wget, etc. You must use a browser or a tool like Postman to make requests. Too many script kiddies out there, sorry about that. 
 *
 * The version of the OpenAPI document: 2.1.0
 * Contact: james@firefly-iii.org
 * Generated by: https://openapi-generator.tech
 */

use crate::models;
use serde::{Deserialize, Serialize};

#[derive(Clone, Default, Debug, PartialEq, Serialize, Deserialize)]
pub struct AccountStore {
    #[serde(rename = "name")]
    pub name: String,
    #[serde(rename = "type")]
    pub r#type: models::ShortAccountTypeProperty,
    #[serde(rename = "iban", default, with = "::serde_with::rust::double_option", skip_serializing_if = "Option::is_none")]
    pub iban: Option<Option<String>>,
    #[serde(rename = "bic", default, with = "::serde_with::rust::double_option", skip_serializing_if = "Option::is_none")]
    pub bic: Option<Option<String>>,
    #[serde(rename = "account_number", default, with = "::serde_with::rust::double_option", skip_serializing_if = "Option::is_none")]
    pub account_number: Option<Option<String>>,
    /// Represents the opening balance, the initial amount this account holds.
    #[serde(rename = "opening_balance", skip_serializing_if = "Option::is_none")]
    pub opening_balance: Option<String>,
    /// Represents the date of the opening balance.
    #[serde(rename = "opening_balance_date", default, with = "::serde_with::rust::double_option", skip_serializing_if = "Option::is_none")]
    pub opening_balance_date: Option<Option<String>>,
    #[serde(rename = "virtual_balance", skip_serializing_if = "Option::is_none")]
    pub virtual_balance: Option<String>,
    /// Use either currency_id or currency_code. Defaults to the user's default currency.
    #[serde(rename = "currency_id", skip_serializing_if = "Option::is_none")]
    pub currency_id: Option<String>,
    /// Use either currency_id or currency_code. Defaults to the user's default currency.
    #[serde(rename = "currency_code", skip_serializing_if = "Option::is_none")]
    pub currency_code: Option<String>,
    /// If omitted, defaults to true.
    #[serde(rename = "active", skip_serializing_if = "Option::is_none")]
    pub active: Option<bool>,
    /// Order of the account
    #[serde(rename = "order", skip_serializing_if = "Option::is_none")]
    pub order: Option<i32>,
    /// If omitted, defaults to true.
    #[serde(rename = "include_net_worth", skip_serializing_if = "Option::is_none")]
    pub include_net_worth: Option<bool>,
    #[serde(rename = "account_role", default, with = "::serde_with::rust::double_option", skip_serializing_if = "Option::is_none")]
    pub account_role: Option<Option<models::AccountRoleProperty>>,
    #[serde(rename = "credit_card_type", default, with = "::serde_with::rust::double_option", skip_serializing_if = "Option::is_none")]
    pub credit_card_type: Option<Option<models::CreditCardTypeProperty>>,
    /// Mandatory when the account_role is ccAsset. Moment at which CC payment installments are asked for by the bank.
    #[serde(rename = "monthly_payment_date", default, with = "::serde_with::rust::double_option", skip_serializing_if = "Option::is_none")]
    pub monthly_payment_date: Option<Option<String>>,
    #[serde(rename = "liability_type", default, with = "::serde_with::rust::double_option", skip_serializing_if = "Option::is_none")]
    pub liability_type: Option<Option<models::LiabilityTypeProperty>>,
    #[serde(rename = "liability_direction", default, with = "::serde_with::rust::double_option", skip_serializing_if = "Option::is_none")]
    pub liability_direction: Option<Option<models::LiabilityDirectionProperty>>,
    /// Mandatory when type is liability. Interest percentage.
    #[serde(rename = "interest", default, with = "::serde_with::rust::double_option", skip_serializing_if = "Option::is_none")]
    pub interest: Option<Option<String>>,
    #[serde(rename = "interest_period", default, with = "::serde_with::rust::double_option", skip_serializing_if = "Option::is_none")]
    pub interest_period: Option<Option<models::InterestPeriodProperty>>,
    #[serde(rename = "notes", default, with = "::serde_with::rust::double_option", skip_serializing_if = "Option::is_none")]
    pub notes: Option<Option<String>>,
    /// Latitude of the accounts's location, if applicable. Can be used to draw a map.
    #[serde(rename = "latitude", default, with = "::serde_with::rust::double_option", skip_serializing_if = "Option::is_none")]
    pub latitude: Option<Option<f64>>,
    /// Latitude of the accounts's location, if applicable. Can be used to draw a map.
    #[serde(rename = "longitude", default, with = "::serde_with::rust::double_option", skip_serializing_if = "Option::is_none")]
    pub longitude: Option<Option<f64>>,
    /// Zoom level for the map, if drawn. This to set the box right. Unfortunately this is a proprietary value because each map provider has different zoom levels.
    #[serde(rename = "zoom_level", default, with = "::serde_with::rust::double_option", skip_serializing_if = "Option::is_none")]
    pub zoom_level: Option<Option<i32>>,
}

impl AccountStore {
    pub fn new(name: String, r#type: models::ShortAccountTypeProperty) -> AccountStore {
        AccountStore {
            name,
            r#type,
            iban: None,
            bic: None,
            account_number: None,
            opening_balance: None,
            opening_balance_date: None,
            virtual_balance: None,
            currency_id: None,
            currency_code: None,
            active: None,
            order: None,
            include_net_worth: None,
            account_role: None,
            credit_card_type: None,
            monthly_payment_date: None,
            liability_type: None,
            liability_direction: None,
            interest: None,
            interest_period: None,
            notes: None,
            latitude: None,
            longitude: None,
            zoom_level: None,
        }
    }
}

