/*
 * Firefly III API v2.1.0
 *
 * This is the documentation of the Firefly III API. You can find accompanying documentation on the website of Firefly III itself (see below). Please report any bugs or issues. You may use the \"Authorize\" button to try the API below. This file was last generated on 2024-09-10T05:07:57+00:00  Please keep in mind that the demo site does not accept requests from curl, colly, wget, etc. You must use a browser or a tool like Postman to make requests. Too many script kiddies out there, sorry about that. 
 *
 * The version of the OpenAPI document: 2.1.0
 * Contact: james@firefly-iii.org
 * Generated by: https://openapi-generator.tech
 */

use crate::models;
use serde::{Deserialize, Serialize};

#[derive(Clone, Default, Debug, PartialEq, Serialize, Deserialize)]
pub struct BillUpdate {
    /// Use either currency_id or currency_code
    #[serde(rename = "currency_id", skip_serializing_if = "Option::is_none")]
    pub currency_id: Option<String>,
    /// Use either currency_id or currency_code
    #[serde(rename = "currency_code", skip_serializing_if = "Option::is_none")]
    pub currency_code: Option<String>,
    #[serde(rename = "name")]
    pub name: String,
    #[serde(rename = "amount_min", skip_serializing_if = "Option::is_none")]
    pub amount_min: Option<String>,
    #[serde(rename = "amount_max", skip_serializing_if = "Option::is_none")]
    pub amount_max: Option<String>,
    #[serde(rename = "date", skip_serializing_if = "Option::is_none")]
    pub date: Option<String>,
    /// The date after which this bill is no longer valid or applicable
    #[serde(rename = "end_date", skip_serializing_if = "Option::is_none")]
    pub end_date: Option<String>,
    /// The date before which the bill must be renewed (or cancelled)
    #[serde(rename = "extension_date", skip_serializing_if = "Option::is_none")]
    pub extension_date: Option<String>,
    #[serde(rename = "repeat_freq", skip_serializing_if = "Option::is_none")]
    pub repeat_freq: Option<models::BillRepeatFrequency>,
    /// How often the bill must be skipped. 1 means a bi-monthly bill.
    #[serde(rename = "skip", skip_serializing_if = "Option::is_none")]
    pub skip: Option<i32>,
    /// If the bill is active.
    #[serde(rename = "active", skip_serializing_if = "Option::is_none")]
    pub active: Option<bool>,
    #[serde(rename = "notes", default, with = "::serde_with::rust::double_option", skip_serializing_if = "Option::is_none")]
    pub notes: Option<Option<String>>,
    /// The group ID of the group this object is part of. NULL if no group.
    #[serde(rename = "object_group_id", default, with = "::serde_with::rust::double_option", skip_serializing_if = "Option::is_none")]
    pub object_group_id: Option<Option<String>>,
    /// The name of the group. NULL if no group.
    #[serde(rename = "object_group_title", default, with = "::serde_with::rust::double_option", skip_serializing_if = "Option::is_none")]
    pub object_group_title: Option<Option<String>>,
}

impl BillUpdate {
    pub fn new(name: String) -> BillUpdate {
        BillUpdate {
            currency_id: None,
            currency_code: None,
            name,
            amount_min: None,
            amount_max: None,
            date: None,
            end_date: None,
            extension_date: None,
            repeat_freq: None,
            skip: None,
            active: None,
            notes: None,
            object_group_id: None,
            object_group_title: None,
        }
    }
}

