/*
 * Firefly III API v2.1.0
 *
 * This is the documentation of the Firefly III API. You can find accompanying documentation on the website of Firefly III itself (see below). Please report any bugs or issues. You may use the \"Authorize\" button to try the API below. This file was last generated on 2024-09-10T05:07:57+00:00  Please keep in mind that the demo site does not accept requests from curl, colly, wget, etc. You must use a browser or a tool like Postman to make requests. Too many script kiddies out there, sorry about that. 
 *
 * The version of the OpenAPI document: 2.1.0
 * Contact: james@firefly-iii.org
 * Generated by: https://openapi-generator.tech
 */

use crate::models;
use serde::{Deserialize, Serialize};

#[derive(Clone, Default, Debug, PartialEq, Serialize, Deserialize)]
pub struct CronResultRow {
    /// This value tells you if this specific cron job actually fired. It may not fire. Some cron jobs only fire every 24 hours, for example. 
    #[serde(rename = "job_fired", default, with = "::serde_with::rust::double_option", skip_serializing_if = "Option::is_none")]
    pub job_fired: Option<Option<bool>>,
    /// This value tells you if this specific cron job actually did something. The job may fire but not change anything. 
    #[serde(rename = "job_succeeded", default, with = "::serde_with::rust::double_option", skip_serializing_if = "Option::is_none")]
    pub job_succeeded: Option<Option<bool>>,
    /// If the cron job ran into some kind of an error, this value will be true.
    #[serde(rename = "job_errored", default, with = "::serde_with::rust::double_option", skip_serializing_if = "Option::is_none")]
    pub job_errored: Option<Option<bool>>,
    /// If the cron job ran into some kind of an error, this value will be the error message. The success message if the job actually ran OK. 
    #[serde(rename = "message", default, with = "::serde_with::rust::double_option", skip_serializing_if = "Option::is_none")]
    pub message: Option<Option<String>>,
}

impl CronResultRow {
    pub fn new() -> CronResultRow {
        CronResultRow {
            job_fired: None,
            job_succeeded: None,
            job_errored: None,
            message: None,
        }
    }
}

