/*
 * Firefly III API v2.1.0
 *
 * This is the documentation of the Firefly III API. You can find accompanying documentation on the website of Firefly III itself (see below). Please report any bugs or issues. You may use the \"Authorize\" button to try the API below. This file was last generated on 2024-09-10T05:07:57+00:00  Please keep in mind that the demo site does not accept requests from curl, colly, wget, etc. You must use a browser or a tool like Postman to make requests. Too many script kiddies out there, sorry about that. 
 *
 * The version of the OpenAPI document: 2.1.0
 * Contact: james@firefly-iii.org
 * Generated by: https://openapi-generator.tech
 */

use crate::models;
use serde::{Deserialize, Serialize};

#[derive(Clone, Default, Debug, PartialEq, Serialize, Deserialize)]
pub struct PiggyBank {
    #[serde(rename = "created_at", skip_serializing_if = "Option::is_none")]
    pub created_at: Option<String>,
    #[serde(rename = "updated_at", skip_serializing_if = "Option::is_none")]
    pub updated_at: Option<String>,
    /// The ID of the asset account this piggy bank is connected to.
    #[serde(rename = "account_id")]
    pub account_id: String,
    /// The name of the asset account this piggy bank is connected to.
    #[serde(rename = "account_name", skip_serializing_if = "Option::is_none")]
    pub account_name: Option<String>,
    #[serde(rename = "name")]
    pub name: String,
    #[serde(rename = "currency_id", skip_serializing_if = "Option::is_none")]
    pub currency_id: Option<String>,
    #[serde(rename = "currency_code", skip_serializing_if = "Option::is_none")]
    pub currency_code: Option<String>,
    #[serde(rename = "currency_symbol", skip_serializing_if = "Option::is_none")]
    pub currency_symbol: Option<String>,
    /// Number of decimals supported by the currency
    #[serde(rename = "currency_decimal_places", skip_serializing_if = "Option::is_none")]
    pub currency_decimal_places: Option<i32>,
    #[serde(rename = "target_amount", deserialize_with = "Option::deserialize")]
    pub target_amount: Option<String>,
    #[serde(rename = "percentage", default, with = "::serde_with::rust::double_option", skip_serializing_if = "Option::is_none")]
    pub percentage: Option<Option<f32>>,
    #[serde(rename = "current_amount", skip_serializing_if = "Option::is_none")]
    pub current_amount: Option<String>,
    #[serde(rename = "left_to_save", default, with = "::serde_with::rust::double_option", skip_serializing_if = "Option::is_none")]
    pub left_to_save: Option<Option<String>>,
    #[serde(rename = "save_per_month", default, with = "::serde_with::rust::double_option", skip_serializing_if = "Option::is_none")]
    pub save_per_month: Option<Option<String>>,
    /// The date you started with this piggy bank.
    #[serde(rename = "start_date", skip_serializing_if = "Option::is_none")]
    pub start_date: Option<String>,
    /// The date you intend to finish saving money.
    #[serde(rename = "target_date", default, with = "::serde_with::rust::double_option", skip_serializing_if = "Option::is_none")]
    pub target_date: Option<Option<String>>,
    #[serde(rename = "order", skip_serializing_if = "Option::is_none")]
    pub order: Option<i32>,
    #[serde(rename = "active", skip_serializing_if = "Option::is_none")]
    pub active: Option<bool>,
    #[serde(rename = "notes", default, with = "::serde_with::rust::double_option", skip_serializing_if = "Option::is_none")]
    pub notes: Option<Option<String>>,
    /// The group ID of the group this object is part of. NULL if no group.
    #[serde(rename = "object_group_id", default, with = "::serde_with::rust::double_option", skip_serializing_if = "Option::is_none")]
    pub object_group_id: Option<Option<String>>,
    /// The order of the group. At least 1, for the highest sorting.
    #[serde(rename = "object_group_order", default, with = "::serde_with::rust::double_option", skip_serializing_if = "Option::is_none")]
    pub object_group_order: Option<Option<i32>>,
    /// The name of the group. NULL if no group.
    #[serde(rename = "object_group_title", default, with = "::serde_with::rust::double_option", skip_serializing_if = "Option::is_none")]
    pub object_group_title: Option<Option<String>>,
}

impl PiggyBank {
    pub fn new(account_id: String, name: String, target_amount: Option<String>) -> PiggyBank {
        PiggyBank {
            created_at: None,
            updated_at: None,
            account_id,
            account_name: None,
            name,
            currency_id: None,
            currency_code: None,
            currency_symbol: None,
            currency_decimal_places: None,
            target_amount,
            percentage: None,
            current_amount: None,
            left_to_save: None,
            save_per_month: None,
            start_date: None,
            target_date: None,
            order: None,
            active: None,
            notes: None,
            object_group_id: None,
            object_group_order: None,
            object_group_title: None,
        }
    }
}

