/*
 * Firefly III API v2.1.0
 *
 * This is the documentation of the Firefly III API. You can find accompanying documentation on the website of Firefly III itself (see below). Please report any bugs or issues. You may use the \"Authorize\" button to try the API below. This file was last generated on 2024-09-10T05:07:57+00:00  Please keep in mind that the demo site does not accept requests from curl, colly, wget, etc. You must use a browser or a tool like Postman to make requests. Too many script kiddies out there, sorry about that. 
 *
 * The version of the OpenAPI document: 2.1.0
 * Contact: james@firefly-iii.org
 * Generated by: https://openapi-generator.tech
 */

use crate::models;
use serde::{Deserialize, Serialize};

#[derive(Clone, Default, Debug, PartialEq, Serialize, Deserialize)]
pub struct Recurrence {
    #[serde(rename = "created_at", skip_serializing_if = "Option::is_none")]
    pub created_at: Option<String>,
    #[serde(rename = "updated_at", skip_serializing_if = "Option::is_none")]
    pub updated_at: Option<String>,
    #[serde(rename = "type", skip_serializing_if = "Option::is_none")]
    pub r#type: Option<models::RecurrenceTransactionType>,
    #[serde(rename = "title", skip_serializing_if = "Option::is_none")]
    pub title: Option<String>,
    /// Not to be confused with the description of the actual transaction(s) being created.
    #[serde(rename = "description", skip_serializing_if = "Option::is_none")]
    pub description: Option<String>,
    /// First time the recurring transaction will fire. Must be after today.
    #[serde(rename = "first_date", skip_serializing_if = "Option::is_none")]
    pub first_date: Option<String>,
    /// Last time the recurring transaction has fired.
    #[serde(rename = "latest_date", default, with = "::serde_with::rust::double_option", skip_serializing_if = "Option::is_none")]
    pub latest_date: Option<Option<String>>,
    /// Date until the recurring transaction can fire. Use either this field or repetitions.
    #[serde(rename = "repeat_until", default, with = "::serde_with::rust::double_option", skip_serializing_if = "Option::is_none")]
    pub repeat_until: Option<Option<String>>,
    /// Max number of created transactions. Use either this field or repeat_until.
    #[serde(rename = "nr_of_repetitions", default, with = "::serde_with::rust::double_option", skip_serializing_if = "Option::is_none")]
    pub nr_of_repetitions: Option<Option<i32>>,
    /// Whether or not to fire the rules after the creation of a transaction.
    #[serde(rename = "apply_rules", skip_serializing_if = "Option::is_none")]
    pub apply_rules: Option<bool>,
    /// If the recurrence is even active.
    #[serde(rename = "active", skip_serializing_if = "Option::is_none")]
    pub active: Option<bool>,
    #[serde(rename = "notes", default, with = "::serde_with::rust::double_option", skip_serializing_if = "Option::is_none")]
    pub notes: Option<Option<String>>,
    #[serde(rename = "repetitions", skip_serializing_if = "Option::is_none")]
    pub repetitions: Option<Vec<models::RecurrenceRepetition>>,
    #[serde(rename = "transactions", skip_serializing_if = "Option::is_none")]
    pub transactions: Option<Vec<models::RecurrenceTransaction>>,
}

impl Recurrence {
    pub fn new() -> Recurrence {
        Recurrence {
            created_at: None,
            updated_at: None,
            r#type: None,
            title: None,
            description: None,
            first_date: None,
            latest_date: None,
            repeat_until: None,
            nr_of_repetitions: None,
            apply_rules: None,
            active: None,
            notes: None,
            repetitions: None,
            transactions: None,
        }
    }
}

