/*
 * Firefly III API v2.1.0
 *
 * This is the documentation of the Firefly III API. You can find accompanying documentation on the website of Firefly III itself (see below). Please report any bugs or issues. You may use the \"Authorize\" button to try the API below. This file was last generated on 2024-09-10T05:07:57+00:00  Please keep in mind that the demo site does not accept requests from curl, colly, wget, etc. You must use a browser or a tool like Postman to make requests. Too many script kiddies out there, sorry about that. 
 *
 * The version of the OpenAPI document: 2.1.0
 * Contact: james@firefly-iii.org
 * Generated by: https://openapi-generator.tech
 */

use crate::models;
use serde::{Deserialize, Serialize};

#[derive(Clone, Default, Debug, PartialEq, Serialize, Deserialize)]
pub struct TransactionLinkStore {
    /// The link type ID to use. You can also use the link_type_name field.
    #[serde(rename = "link_type_id")]
    pub link_type_id: String,
    /// The link type name to use. You can also use the link_type_id field.
    #[serde(rename = "link_type_name", skip_serializing_if = "Option::is_none")]
    pub link_type_name: Option<String>,
    /// The inward transaction transaction_journal_id for the link. This becomes the 'is paid by' transaction of the set.
    #[serde(rename = "inward_id")]
    pub inward_id: String,
    /// The outward transaction transaction_journal_id for the link. This becomes the 'pays for' transaction of the set.
    #[serde(rename = "outward_id")]
    pub outward_id: String,
    /// Optional. Some notes.
    #[serde(rename = "notes", default, with = "::serde_with::rust::double_option", skip_serializing_if = "Option::is_none")]
    pub notes: Option<Option<String>>,
}

impl TransactionLinkStore {
    pub fn new(link_type_id: String, inward_id: String, outward_id: String) -> TransactionLinkStore {
        TransactionLinkStore {
            link_type_id,
            link_type_name: None,
            inward_id,
            outward_id,
            notes: None,
        }
    }
}

