/*
 * Firefly III API v2.1.0
 *
 * This is the documentation of the Firefly III API. You can find accompanying documentation on the website of Firefly III itself (see below). Please report any bugs or issues. You may use the \"Authorize\" button to try the API below. This file was last generated on 2024-09-10T05:07:57+00:00  Please keep in mind that the demo site does not accept requests from curl, colly, wget, etc. You must use a browser or a tool like Postman to make requests. Too many script kiddies out there, sorry about that. 
 *
 * The version of the OpenAPI document: 2.1.0
 * Contact: james@firefly-iii.org
 * Generated by: https://openapi-generator.tech
 */

use crate::models;
use serde::{Deserialize, Serialize};

#[derive(Clone, Default, Debug, PartialEq, Serialize, Deserialize)]
pub struct WebhookAttempt {
    #[serde(rename = "created_at", skip_serializing_if = "Option::is_none")]
    pub created_at: Option<String>,
    #[serde(rename = "updated_at", skip_serializing_if = "Option::is_none")]
    pub updated_at: Option<String>,
    /// The ID of the webhook message this attempt belongs to.
    #[serde(rename = "webhook_message_id", skip_serializing_if = "Option::is_none")]
    pub webhook_message_id: Option<String>,
    /// The HTTP status code of the error, if any.
    #[serde(rename = "status_code", default, with = "::serde_with::rust::double_option", skip_serializing_if = "Option::is_none")]
    pub status_code: Option<Option<i32>>,
    /// Internal log for this attempt. May contain sensitive user data.
    #[serde(rename = "logs", default, with = "::serde_with::rust::double_option", skip_serializing_if = "Option::is_none")]
    pub logs: Option<Option<String>>,
    /// Webhook receiver response for this attempt, if any. May contain sensitive user data.
    #[serde(rename = "response", default, with = "::serde_with::rust::double_option", skip_serializing_if = "Option::is_none")]
    pub response: Option<Option<String>>,
}

impl WebhookAttempt {
    pub fn new() -> WebhookAttempt {
        WebhookAttempt {
            created_at: None,
            updated_at: None,
            webhook_message_id: None,
            status_code: None,
            logs: None,
            response: None,
        }
    }
}

