# Rust API client for gocardless-bankaccount-data-api

No description provided (generated by Openapi Generator https://github.com/openapitools/openapi-generator)


## Overview

This API client was generated by the [OpenAPI Generator](https://openapi-generator.tech) project.  By using the [openapi-spec](https://openapis.org) from a remote server, you can easily generate an API client.

- API version: 2.0 (v2)
- Package version: 2.0.0
- Generator version: 7.9.0-SNAPSHOT
- Build package: `org.openapitools.codegen.languages.RustClientCodegen`

## Installation

Put the package under your project folder in a directory named `gocardless-bankaccount-data-api` and add the following to `Cargo.toml` under `[dependencies]`:

```
gocardless-bankaccount-data-api = { path = "./gocardless-bankaccount-data-api" }
```

## Documentation for API Endpoints

All URIs are relative to *https://bankaccountdata.gocardless.com*

Class | Method | HTTP request | Description
------------ | ------------- | ------------- | -------------
*AccountsApi* | [**retrieve_account_balances**](docs/AccountsApi.md#retrieve_account_balances) | **GET** /api/v2/accounts/{id}/balances/ | 
*AccountsApi* | [**retrieve_account_details**](docs/AccountsApi.md#retrieve_account_details) | **GET** /api/v2/accounts/{id}/details/ | 
*AccountsApi* | [**retrieve_account_metadata**](docs/AccountsApi.md#retrieve_account_metadata) | **GET** /api/v2/accounts/{id}/ | 
*AccountsApi* | [**retrieve_account_transactions**](docs/AccountsApi.md#retrieve_account_transactions) | **GET** /api/v2/accounts/{id}/transactions/ | 
*AgreementsApi* | [**accept_eua**](docs/AgreementsApi.md#accept_eua) | **PUT** /api/v2/agreements/enduser/{id}/accept/ | 
*AgreementsApi* | [**create_eua**](docs/AgreementsApi.md#create_eua) | **POST** /api/v2/agreements/enduser/ | 
*AgreementsApi* | [**delete_eua_by_id**](docs/AgreementsApi.md#delete_eua_by_id) | **DELETE** /api/v2/agreements/enduser/{id}/ | 
*AgreementsApi* | [**retrieve_all_euas_for_an_end_user**](docs/AgreementsApi.md#retrieve_all_euas_for_an_end_user) | **GET** /api/v2/agreements/enduser/ | 
*AgreementsApi* | [**retrieve_eua_by_id**](docs/AgreementsApi.md#retrieve_eua_by_id) | **GET** /api/v2/agreements/enduser/{id}/ | 
*InstitutionsApi* | [**retrieve_all_supported_institutions_in_a_given_country**](docs/InstitutionsApi.md#retrieve_all_supported_institutions_in_a_given_country) | **GET** /api/v2/institutions/ | 
*InstitutionsApi* | [**retrieve_institution**](docs/InstitutionsApi.md#retrieve_institution) | **GET** /api/v2/institutions/{id}/ | 
*RequisitionsApi* | [**create_requisition**](docs/RequisitionsApi.md#create_requisition) | **POST** /api/v2/requisitions/ | 
*RequisitionsApi* | [**delete_requisition_by_id**](docs/RequisitionsApi.md#delete_requisition_by_id) | **DELETE** /api/v2/requisitions/{id}/ | 
*RequisitionsApi* | [**requisition_by_id**](docs/RequisitionsApi.md#requisition_by_id) | **GET** /api/v2/requisitions/{id}/ | 
*RequisitionsApi* | [**retrieve_all_requisitions**](docs/RequisitionsApi.md#retrieve_all_requisitions) | **GET** /api/v2/requisitions/ | 
*TokenApi* | [**get_a_new_access_token**](docs/TokenApi.md#get_a_new_access_token) | **POST** /api/v2/token/refresh/ | 
*TokenApi* | [**obtain_new_access_slash_refresh_token_pair**](docs/TokenApi.md#obtain_new_access_slash_refresh_token_pair) | **POST** /api/v2/token/new/ | 


## Documentation For Models

 - [Account](docs/Account.md)
 - [AccountBalance](docs/AccountBalance.md)
 - [AccountDetail](docs/AccountDetail.md)
 - [AccountSchema](docs/AccountSchema.md)
 - [BalanceAmountSchema](docs/BalanceAmountSchema.md)
 - [BalanceSchema](docs/BalanceSchema.md)
 - [BankTransaction](docs/BankTransaction.md)
 - [CurrencyExchangeSchema](docs/CurrencyExchangeSchema.md)
 - [DetailSchema](docs/DetailSchema.md)
 - [EndUserAgreement](docs/EndUserAgreement.md)
 - [EndUserAgreementRequest](docs/EndUserAgreementRequest.md)
 - [EnduserAcceptanceDetailsRequest](docs/EnduserAcceptanceDetailsRequest.md)
 - [ErrorResponse](docs/ErrorResponse.md)
 - [Integration](docs/Integration.md)
 - [IntegrationRetrieve](docs/IntegrationRetrieve.md)
 - [JwtObtainPairRequest](docs/JwtObtainPairRequest.md)
 - [JwtRefreshRequest](docs/JwtRefreshRequest.md)
 - [OwnerAddressStructuredSchema](docs/OwnerAddressStructuredSchema.md)
 - [PaginatedEndUserAgreementList](docs/PaginatedEndUserAgreementList.md)
 - [PaginatedRequisitionList](docs/PaginatedRequisitionList.md)
 - [Requisition](docs/Requisition.md)
 - [RequisitionRequest](docs/RequisitionRequest.md)
 - [SpectacularJwtObtain](docs/SpectacularJwtObtain.md)
 - [SpectacularJwtRefresh](docs/SpectacularJwtRefresh.md)
 - [SpectacularRequisition](docs/SpectacularRequisition.md)
 - [StatusEnum](docs/StatusEnum.md)
 - [TransactionAmountSchema](docs/TransactionAmountSchema.md)
 - [TransactionSchema](docs/TransactionSchema.md)


To get access to the crate's generated documentation, use:

```
cargo doc --open
```

## Author



